#include <bits/stdc++.h>
#define ull unsigned long long
#define pii pair<int, int>
#define N 1000000
using namespace std;
vector<vector<long long>> doha;
vector<vector<long long>> dp;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin>>n>>m;
    doha.resize(n);
    for(int i = 0; i<n; i++)
    {
        doha[i].resize(m);
        for(int j = 0; j<m; j++)
            cin>>doha[i][j];
    }

    int q;cin>>q;
    for(int qq = 0; qq<q; qq++)
    {
        int x, y;cin>>x>>y;
        x--;y--;
        dp.resize(n);
        for(int i = 0; i<n; i++)
            dp[i].resize(m);
        long long old = doha[x][y];
        doha[x][y]=1000000003;
        dp[0][0]=doha[0][0];
        for(int j = 1; j<m; j++)
            dp[0][j]=doha[0][j]+dp[0][j-1];
        for(int i = 1; i<n; i++)
            dp[i][0] = doha[i][0]+dp[i-1][0];

        for(int i = 1; i<n; i++)
            for(int j = 1; j<m; j++)
                dp[i][j]=doha[i][j] + min(dp[i-1][j], dp[i][j-1]);

        cout<<dp[n-1][m-1]<<"\n";
        doha[x][y]=old;
    }
    return 0;
}